; only need around 9 decimal places to calc planets
; here is 14//e $ldiv(22,7) = 3.14285714285714
; alias lib return irc.dll
alias -l lib return math.dll

alias lacos return $dll($lib,dacos@24,$1)
alias lsin return $dll($lib,dsin@24,$1)
alias lasin return $dll($lib,dasin@24,$1)
alias lcos return $dll($lib,dcos@24,$1)
alias lsub return $dll($lib,dsub@24,$1-)
alias ladd return $dll($lib,dadd@24,$1-)
alias ldiv return $dll($lib,ddiv@24,$1-)
alias lmult return $dll($lib,dmult@24,$1-)
alias lsqrt return $dll($lib,dsqrt@24,$1)
alias lpow return $dll($lib,dpow@24,$1-)
alias lmod return $dll($lib,dmod@24,$1-)
alias lround return $dll($lib,dround@24,$1-)
alias atan2 {
  tokenize 32 $1-
  ; var %s = $2 $1 
  var %s = $1 $2 
  return $dll($lib,datan2@24,%s)
}
; 13 math to the 14th decimal
alias EXPORTS {
  dacos@24 @3
  dadd@24 @4
  dasin@24 @5
  datan2@24 @6
  dcos@24 @7
  ddiv@24 @8
  dmod@24 @9
  dmult@24 @10
  dpow@24 @11
  dround@24 @12
  dsin@24 @13
  dsqrt@24 @14
  dsub@24 @15
  ; 13 math
  invmatrix@24 @24
  loadll@24 @25
  reverse@24 @31
  unloadchk@24 @34
  unloadll@24 @35
  ; //dll math.dll reverse@24 hello
}
alias initpi {
  %PI = 3.141592653589793238
  %PI2 = $lmult(2.0,%PI)
  %PI.5 = $ldiv(%PI,2.0)
  %PI1.5 = $ladd(%PI.5, %PI)
  %PI1.5 = $lmult(1.5, %PI)
  %PHI = $ladd($ldiv($lsub($lsqrt(5) 1) 2) 1)
  if (10) {
    e %PI
    e %PI2
    e %PI.5
    e %PI1.5
    e %PHI
  }
  %PI = 3.14159265358979324
  %PI2 = 6.283185307179586
  %PI.5 = 1.570796326794897
  %PI1.5 = 4.71238898038469
}
alias e echo -s $1-
alias ec e $calc($1-)
alias midpoint {
  tokenize 32 $1-
  return $calc(($1 + $4) / 2) $calc(($2 + $5) / 2) $calc(($3 + $6) / 2)
}
alias incenter {
  tokenize 32 $1-
  var %a = $1 $2 $3
  var %b = $4 $5 $6
  var %c = $7 $8 $9
  var %x = $subv(%a,%b)
  var %y = $subv(%b,%c)
  var %z = $subv(%c,%a)
  var %l = $vlen(%x)
  var %l2 = $vlen(%y)
  var %l3 = $vlen(%z)
  %x = $multv(%c,%l)
  %y = $multv(%a,%l2)
  %z = $multv(%b,%l3)
  %x = $addv(%x,%y)
  %x = $addv(%x,%z)
  return $divv(%x,$calc(%l + %l2 + %l3))
}
alias samel1 {
  var %l = $vlen2($1)
  if (%l > 0) return $multv2($1,$calc($2 / %l))
  else return $1
}
alias samel {
  return $multv2($normalize2($1),$2)
}
alias samel3d {
  return $multv($normalize($1),$2)
}
alias vlen2 {
  tokenize 32 $1-
  return $sqrt($calc(($1 ^ 2) + ($2 ^ 2)))
}
alias subv2 {
  tokenize 32 $1-
  return $calc($1 - $3) $calc($2 - $4)
}
alias addv2 {
  tokenize 32 $1-
  return $calc($1 + $3) $calc($2 + $4)
}
alias normalize2 {
  var %d = $vlen($1-)
  if (%d == 0) return $1-
  tokenize 32 $1-
  return $calc($1 / %d) $calc($2 / %d)
}
alias vlen {
  tokenize 32 $1-
  return $sqrt($calc(($1 ^ 2) + ($2 ^ 2) + ($3 ^ 2)))
}
alias normalize44 {
  if ($chr(44) isin $1) tokenize 44 $1-
  var %d = $vlen($1 $2 $3)
  if (%d == 0) return $1-
  return $+($calc($1 / %d),$chr(44),$calc($2 / %d),$chr(44),$calc($3 / %d))
}
alias normalize {
  tokenize 32 $1-
  var %d = $vlen($1 $2 $3)
  if (%d == 0) return $1-
  return $+($calc($1 / %d) $calc($2 / %d) $calc($3 / %d))
}
alias radang2 {
  tokenize 32 $1-
  var %v = $1 $2, %v2 = $3 $4, %d = $calc($vlen2(%v) * $vlen2(%v2))
  if (%d <= 0) { e 4 $ifmatch divide by 0 error | %d = 1 }
  %d = $acos($calc($dotprod2(%v,%v2) / %d))
  if (%d < 0) return 0
  return %d
}
alias dotprod2 {
  tokenize 32 $1-
  return $calc(($1 * $3) + ($2 * $4))
}
alias multv2 {
  tokenize 32 $1-
  return $calc($1 * $3) $calc($2 * $3)
}
alias multv23 {
  tokenize 32 $1-
  return $calc($1 * $4) $calc($2 * $5) $calc($3 * $6)
}
alias multv {
  tokenize 32 $1-
  return $calc($1 * $4) $calc($2 * $4) $calc($3 * $4)
}
alias divv {
  tokenize 32 $1-
  return $calc($1 / $4) $calc($2 / $4) $calc($3 / $4)
}
alias divv2 {
  tokenize 32 $1-
  return $calc($1 / $3) $calc($2 / $3)
}
alias angle2 {
  var %v = $subv2($2,$1), %v2 = $subv2($3,$1), %d = $calc($vlen2(%v) * $vlen2(%v2))
  if (%d <= 0) { e 4 $ifmatch divide by 0 error | %d = 1 }
  %d = $acos($calc($dotprod2(%v,%v2) / %d))
  if (%d < 0) return 0
  return $calc(57.29577 * %d)
  =186
}
alias angle {
  var %v = $normalize($1), %v2 = $normalize($2)
  return $acos(%clamp($dotprod(%v,%v2)),-1,1)
  return $calc(57.29577 * %d)
  =186
}
alias clamp {
  if ($1 < $2) return $2
  if ($1 > $3) return $3
  return $1
}

alias subv {
  tokenize 32 $1-
  return $calc($1 - $4) $calc($2 - $5) $calc($3 - $6)
}
alias dotprod {
  tokenize 32 $1-
  return $calc(($1 * $4) + ($2 * $5) + ($3 * $6))
}

alias radec2pos {
  var %dec = $2 * -1;  // invert for y+ = down system
  return $calc($3 * $cos($1) * $cos(%dec)) $calc($3 * $sin(%dec)) $calc($3 * $sin($1) * $cos(%dec))
}


alias ssa_acute {
  return $asin($calc($2 * $sin($3) / $1))
  ; (s,ss,a) asin(ss*sin(a)/s)
  ; angle opposite side2
}
alias sas_cos {
  return $calc($sqrt($calc(($1 ^ 2) + ($3 ^ 2))) - (2 * $1 * $3 * $cos($2))))
  ; (s,a,ss) sqrt((pow(s,2)+pow(ss,2))-(2*s*ss*cos(a)))
  ; Side Angle Side - solve length of missing side
}
alias aas_sin {
  return $calc($sin($2) * ($3 / $sin($1)))
  ; (a,b,s) sin(b) * (s / sin(a))
  ; AAS solve opposing side of angle2 (b)
}
alias asa_sin {
  return $calc($sin($3) * ($2 / $sin($calc(%PI - ($1 + $3)))))
  ; (a,s,b) sin(b) * (s / sin(PI-(a+b)))
  ; ASA solve opposing side of angle2 (b)
}

alias sss_cos {
  return $acos($calc((($1 ^ 2) + ($3 ^ 2) - ($2 ^ 2)) / (2 * $1 * $3)))
  ; (a,b,c) acos((pow(a,2)+pow(c,2)-pow(b,2))/(2*a*c))
  ; SSS solve angle opposite side2 (b)
  ; if (pow(a,2)+pow(c,2)-pow(b,2))/(2*a*c) < 0 obtuse
}
alias ssa_obtuse1 {
  var %h = $calc($sin($3) * $2))
  return $calc(%PI - $asin($calc(%h / $1)))
}
alias ssa_obtuse_in(s,ss,a) {
  ; input the obtuse angle
  return $ssa_acute($1,$2,$calc(%PI - a))
}
alias ssa_obtuse {
  ; return the obtuse angle
  return $calc(%PI - $ssa_acute($1,$2,$3))
}
alias dtor {
  return $calc($1 / 57.29578)
}
alias rtod {
  return $calc($1 * 57.29578)
}
alias answer {
  e $fov2fol(30,400)
  e $asa_sin( $dtor(125), .5, %PI.5)

  ; 30
  ; $dtor(15)
}

alias fov2fol {
  ; (double deg, int centerx)
  var %a = $dtor($calc((180 - $CLAMP($1,0.0001,160.0)) / 2))
  e %PI.5 $2 %a
  return $asa_sin(%PI.5,$2,%a)
}
alias ausinaparsec return 206264.80624709636
alias lightspeedkm return 299792.458
alias lightspeedmi return 186282.39705122085

alias lightyearkm return $lmult($lightspeedkm, $jsecyear)
alias lightyearmi { return $lmult($lightspeedmi, $jsecyear) }
alias jsecyear { return $lmult($secday, 365.25) }
alias gsecyear { return $lmult($secday, 365.2425) }
alias secday { return 86400 }

alias au2pc return $ldiv($1, $ausinaparsec)
alias au2km return $lmult($1,149597870.691)
alias au2ly return $pc2ly($au2pc($1))
alias au2mi return $km2mi($au2km($1))
alias au2mi2 return $lmult($1,92956038.308250591)

; alias pc2ly return $lmult($1,$km2ly($pc2km(1)))
alias pc2ly return $lmult($1,3.261563776971214)
; alias pc2km return $lmult($lmult($1,$au2km(1)),$ausinaparsec)
alias pc2km return $lmult($1,30856775813057.285)
alias pc2au return $lmult($1, $ausinaparsec)
alias pc2mi return $km2mi($pc2km($1))
alias pc2mi2 return $lmult($1,19173559231148.973)

alias mi2ly { return $ldiv($1, $lightyearmi) }
alias mi2au return $km2au($mi2km($1))
alias mi2pc return $ldiv($1,19173559231148.973)
alias mi2km return $lmult($1, 1.60934)

alias ly2mi { return $lmult($1, $lightyearmi) }
alias ly2km return $lmult($1, $lightyearkm)
alias ly2pc return $ldiv($1,3.261563776971214)
alias ly2au return $pc2au($ly2pc($1))

alias km2ly return $ldiv($1, $lightyearkm)
alias km2mi return $ldiv($1, 1.60934)
alias km2au return $div($1,149597870.691)
alias km2pc return $ldiv($1,30856775813057.285)


alias marcsec2rad {
  ; (ma)
  return $ldiv($1 , 206264806.24709636)
} ; (648000000 / PI) ausinaparsec()*1000
alias parallax2parsec {
  ; (parallax-mas)
  ; var %r = $marcsec2rad($1)
  ; return $lmult($ldiv($au2pc(1) , $lsin(%r)) , $lsin($lsub(%PI.5 - %r)))
  return $ldiv(1,$ldiv($1,1000.0))
  ; different result - fewer calcs more correct?
  ; 1827.41231664308340
  ; 1827.41134971493400
}
alias lyears {
  ; (parallax-mas)
  return $pc2ly($parallax2parsec($1))
  return $lmult($parallax2parsec(1.7838), 3.261563776971214)
}
alias leapyear {
  if (((!$calc($1 % 4)) && $calc($1 % 100)) || (!$calc($1 % 400))) return 29
  return  28
}
